"use strict";

var _core = require("babel-runtime/core-js")["default"];

var _interopRequire = require("babel-runtime/helpers/interop-require")["default"];

module.exports = fastpather;

var fastpath = _interopRequire(require("./lib/fastPath"));

function fastpather(pattern) {
    var input = {};
    var output = {};
    if (typeof pattern === "string") {
        //simple string patterns
        return fastpath(pattern);
    } else {
        //named patterns
        return traverse(pattern);
    }
}

function traverse(object) {
    var keys = _core.Object.keys(object);
    keys.forEach(function (entry) {
        if (typeof object[entry] === "object") {
            traverse(object[entry]);
        } else if (typeof object[entry] === "string") {
            object[entry] = fastpath(object[entry]);
        }
        //we ignore all other basic types.
    });
    return {
        evaluate: function evaluate(obj) {
            var result = _core.Object.assign({}, object);
            return evalObj(obj, result);
        }
    };
}

function evalObj(object, pattern) {
    var keys = _core.Object.keys(pattern);

    keys.forEach(function (entry) {
        if (pattern[entry].evaluate && typeof pattern[entry].evaluate === "function") {
            pattern[entry] = pattern[entry].evaluate(object);
        } else if (typeof pattern[entry] === "object") {
            evalObj(object, pattern[entry]);
        }
    });
    return pattern;
}